*** /d/postgresql-snapshot-new/contrib/tsearch2/tsvector.c	Fri Apr  2 02:41:18 2004
--- ./tsvector.c	Tue May 11 18:23:23 2004
***************
*** 573,596 ****
  static int
  compareWORD(const void *a, const void *b)
  {
! 	if (((WORD *) a)->len == ((WORD *) b)->len)
  	{
  		int			res = strncmp(
! 								  ((WORD *) a)->word,
! 								  ((WORD *) b)->word,
! 								  ((WORD *) b)->len);
  
  		if (res == 0)
! 			return (((WORD *) a)->pos.pos > ((WORD *) b)->pos.pos) ? 1 : -1;
  		return res;
  	}
! 	return (((WORD *) a)->len > ((WORD *) b)->len) ? 1 : -1;
  }
  
  static int
! uniqueWORD(WORD * a, int4 l)
  {
! 	WORD	   *ptr,
  			   *res;
  	int			tmppos;
  
--- 573,596 ----
  static int
  compareWORD(const void *a, const void *b)
  {
! 	if (((TSWORD *) a)->len == ((TSWORD *) b)->len)
  	{
  		int			res = strncmp(
! 								  ((TSWORD *) a)->word,
! 								  ((TSWORD *) b)->word,
! 								  ((TSWORD *) b)->len);
  
  		if (res == 0)
! 			return (((TSWORD *) a)->pos.pos > ((TSWORD *) b)->pos.pos) ? 1 : -1;
  		return res;
  	}
! 	return (((TSWORD *) a)->len > ((TSWORD *) b)->len) ? 1 : -1;
  }
  
  static int
! uniqueWORD(TSWORD * a, int4 l)
  {
! 	TSWORD	   *ptr,
  			   *res;
  	int			tmppos;
  
***************
*** 607,613 ****
  	res = a;
  	ptr = a + 1;
  
! 	qsort((void *) a, l, sizeof(WORD), compareWORD);
  	tmppos = LIMITPOS(a->pos.pos);
  	a->alen = 2;
  	a->pos.apos = (uint16 *) palloc(sizeof(uint16) * a->alen);
--- 607,613 ----
  	res = a;
  	ptr = a + 1;
  
! 	qsort((void *) a, l, sizeof(TSWORD), compareWORD);
  	tmppos = LIMITPOS(a->pos.pos);
  	a->alen = 2;
  	a->pos.apos = (uint16 *) palloc(sizeof(uint16) * a->alen);
***************
*** 728,734 ****
  	prs.lenwords = 32;
  	prs.curwords = 0;
  	prs.pos = 0;
! 	prs.words = (WORD *) palloc(sizeof(WORD) * prs.lenwords);
  
  	parsetext_v2(cfg, &prs, VARDATA(in), VARSIZE(in) - VARHDRSZ);
  	PG_FREE_IF_COPY(in, 1);
--- 728,734 ----
  	prs.lenwords = 32;
  	prs.curwords = 0;
  	prs.pos = 0;
! 	prs.words = (WORD *) palloc(sizeof(TSWORD) * prs.lenwords);
  
  	parsetext_v2(cfg, &prs, VARDATA(in), VARSIZE(in) - VARHDRSZ);
  	PG_FREE_IF_COPY(in, 1);
***************
*** 853,859 ****
  	prs.lenwords = 32;
  	prs.curwords = 0;
  	prs.pos = 0;
! 	prs.words = (WORD *) palloc(sizeof(WORD) * prs.lenwords);
  
  	/* find all words in indexable column */
  	for (i = 1; i < trigger->tgnargs; i++)
--- 853,859 ----
  	prs.lenwords = 32;
  	prs.curwords = 0;
  	prs.pos = 0;
! 	prs.words = (TSWORD *) palloc(sizeof(TSWORD) * prs.lenwords);
  
  	/* find all words in indexable column */
  	for (i = 1; i < trigger->tgnargs; i++)
